searchData={"content_type":"text/markdown","items":[{"doc":"Helper functions for supporting EmqttFailover.","ref":"EmqttFailover.html","title":"EmqttFailover","type":"module"},{"doc":"Generate a unique client ID, like `\" - - \"`\n\nOptions:\n- `prefix`: defaults to `\"emqtt-f\"`\n- `hostname`: defaults to the value of `:inet.gethostname()`","ref":"EmqttFailover.html#client_id/1","title":"EmqttFailover.client_id/1","type":"function"},{"doc":"","ref":"EmqttFailover.html#t:client_id_opt/0","title":"EmqttFailover.client_id_opt/0","type":"type"},{"doc":"Configuration for connecting to an MQTT broker.","ref":"EmqttFailover.Config.html","title":"EmqttFailover.Config","type":"module"},{"doc":"Default `ssl_opts` configuration.\n\nVerifies the remote peer using the built-in `:public_key.cacerts.get()` certificates.","ref":"EmqttFailover.Config.html#default_ssl_opts/1","title":"EmqttFailover.Config.default_ssl_opts/1","type":"function"},{"doc":"Converts a %URI{} struct into a %Elixir.EmqttFailover.Config struct.","ref":"EmqttFailover.Config.html#from_uri/2","title":"EmqttFailover.Config.from_uri/2","type":"function"},{"doc":"Converts a URL into a %Elixir.EmqttFailover.Config{} struct.","ref":"EmqttFailover.Config.html#from_url/2","title":"EmqttFailover.Config.from_url/2","type":"function"},{"doc":"Returns the ssl_opts to use for the given %Elixir.EmqttFailover.Config","ref":"EmqttFailover.Config.html#ssl_opts/1","title":"EmqttFailover.Config.ssl_opts/1","type":"function"},{"doc":"Returns a `Keyword.t()` of options to pass to `:emqtt.start_link/1`","ref":"EmqttFailover.Config.html#to_emqtt/1","title":"EmqttFailover.Config.to_emqtt/1","type":"function"},{"doc":"Renders the %Elixir.EmqttFailover.Config as a safe URL (no password)","ref":"EmqttFailover.Config.html#to_safe_string/1","title":"EmqttFailover.Config.to_safe_string/1","type":"function"},{"doc":"","ref":"EmqttFailover.Config.html#t:t/0","title":"EmqttFailover.Config.t/0","type":"type"},{"doc":"Wraps an :emqtt client.","ref":"EmqttFailover.Connection.html","title":"EmqttFailover.Connection","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"EmqttFailover.Connection.html#child_spec/1","title":"EmqttFailover.Connection.child_spec/1","type":"function"},{"doc":"Publishes a message to the broker.\n\nFor more on the message, see `EmqttFailover.Message`.\n\nFor `qos: 0` messages, this always returns `:ok`\n\nIf the message has `qos: 1` or `qos: 2` and the server is not connected or the message is not acknowledged, this will return an error.","ref":"EmqttFailover.Connection.html#publish/3","title":"EmqttFailover.Connection.publish/3","type":"function"},{"doc":"Publishes a message to the broker without waiting for a reply.\n\nFor more on the message, see `EmqttFailover.Message`.","ref":"EmqttFailover.Connection.html#publish_async/2","title":"EmqttFailover.Connection.publish_async/2","type":"function"},{"doc":"Start a `Elixir.EmqttFailover.Connection`.\n\nRequired parameters:\n- `configs`: an Enumerable of URLs or `EmqttFailover.Config` structs. These will be tried in order.\n\nOptional parameters:\n\n- `backoff`: either a single number of milliseconds to wait after a connection\n  failure, a tuple `{start, max}` where `start` and `max` are the initial and\n  maximum number of milliseconds to wait, or `{start, max, :jitter}` to add\n  some random jitter to the specific reconnection times. Note: this backoff\n  timeout will only be used after all the failover connections have been tried.\n\n- `client_id`: a binary to be used as the identifier for this client\n\n- `handler`: either a module implementing `EmqttFailover.ConnectionHandler` or\n  a tuple `{module, init_args}` where `init_args` are passed to the module's\n  `init/1` function.","ref":"EmqttFailover.Connection.html#start_link/1","title":"EmqttFailover.Connection.start_link/1","type":"function"},{"doc":"Returns the current connection status, along with the configuration for the connection.\n\nIf the `status` is `:not_connected`, the config that is returned is the next one that will be tried.","ref":"EmqttFailover.Connection.html#status/1","title":"EmqttFailover.Connection.status/1","type":"function"},{"doc":"Gracefully stops the connection.","ref":"EmqttFailover.Connection.html#stop/2","title":"EmqttFailover.Connection.stop/2","type":"function"},{"doc":"","ref":"EmqttFailover.Connection.html#t:backoff/0","title":"EmqttFailover.Connection.backoff/0","type":"type"},{"doc":"","ref":"EmqttFailover.Connection.html#t:config/0","title":"EmqttFailover.Connection.config/0","type":"type"},{"doc":"","ref":"EmqttFailover.Connection.html#t:handler/0","title":"EmqttFailover.Connection.handler/0","type":"type"},{"doc":"","ref":"EmqttFailover.Connection.html#t:param/0","title":"EmqttFailover.Connection.param/0","type":"type"},{"doc":"","ref":"EmqttFailover.Connection.html#t:status/0","title":"EmqttFailover.Connection.status/0","type":"type"},{"doc":"Behavior for handling messages in an EmqttFailover.Connection.","ref":"EmqttFailover.ConnectionHandler.html","title":"EmqttFailover.ConnectionHandler","type":"behaviour"},{"doc":"","ref":"EmqttFailover.ConnectionHandler.html#c:handle_connected/1","title":"EmqttFailover.ConnectionHandler.handle_connected/1","type":"callback"},{"doc":"","ref":"EmqttFailover.ConnectionHandler.html#c:handle_disconnected/2","title":"EmqttFailover.ConnectionHandler.handle_disconnected/2","type":"callback"},{"doc":"","ref":"EmqttFailover.ConnectionHandler.html#c:handle_message/2","title":"EmqttFailover.ConnectionHandler.handle_message/2","type":"callback"},{"doc":"","ref":"EmqttFailover.ConnectionHandler.html#c:init/1","title":"EmqttFailover.ConnectionHandler.init/1","type":"callback"},{"doc":"","ref":"EmqttFailover.ConnectionHandler.html#t:state/0","title":"EmqttFailover.ConnectionHandler.state/0","type":"type"},{"doc":"Default EmqttFailover.Connection which does nothing.","ref":"EmqttFailover.ConnectionHandler.Default.html","title":"EmqttFailover.ConnectionHandler.Default","type":"module"},{"doc":"","ref":"EmqttFailover.ConnectionHandler.Default.html#handle_connected/1","title":"EmqttFailover.ConnectionHandler.Default.handle_connected/1","type":"function"},{"doc":"","ref":"EmqttFailover.ConnectionHandler.Default.html#handle_disconnected/2","title":"EmqttFailover.ConnectionHandler.Default.handle_disconnected/2","type":"function"},{"doc":"","ref":"EmqttFailover.ConnectionHandler.Default.html#handle_message/2","title":"EmqttFailover.ConnectionHandler.Default.handle_message/2","type":"function"},{"doc":"`EmqttFailover.ConnectionHandler` which sends messages back to a parent\nprocess.\n\nMessages:\n- `{:connected, pid}` on connection, where `pid` is the `EmqttFailover.Connection` process\n- `{:disconnected, pid, reason}` on disconnection\n- `{:message, pid, message}` on receipt of a message\n\nOptions:\n- `parent` (required): parent process to send messages to\n- `topics` (optional): list of topics to subscribe to on connection.","ref":"EmqttFailover.ConnectionHandler.Parent.html","title":"EmqttFailover.ConnectionHandler.Parent","type":"module"},{"doc":"A message to/from an MQTT topic.","ref":"EmqttFailover.Message.html","title":"EmqttFailover.Message","type":"module"},{"doc":"- 0: at most once\n- 1: at least once\n- 2: exactly once","ref":"EmqttFailover.Message.html#module-qos-quality-of-server","title":"QOS (Quality of Server) - EmqttFailover.Message","type":"module"},{"doc":"Each topic can have one retained message, which is sent to clients when they subscribe to the topic.\n\nIf `retain?` is true when sending the message, the message will be the new retained message on the topic.\nIf `retain?` is true when receiving the message, the message was the retained message on the topic.\n\nNote: once the client has subscribed to the topic, new messages send with the\n`retain?` flag will not be received with the `retain?` flag set.","ref":"EmqttFailover.Message.html#module-retain","title":"Retain? - EmqttFailover.Message","type":"module"},{"doc":"","ref":"EmqttFailover.Message.html#t:payload/0","title":"EmqttFailover.Message.payload/0","type":"type"},{"doc":"","ref":"EmqttFailover.Message.html#t:t/0","title":"EmqttFailover.Message.t/0","type":"type"},{"doc":"","ref":"EmqttFailover.Message.html#t:topic/0","title":"EmqttFailover.Message.topic/0","type":"type"},{"doc":"# EmqttFailover\n\n[![pipeline status](https://gitlab.com/paulswartz/emqtt_failover/badges/main/pipeline.svg)](https://gitlab.com/paulswartz/emqtt_failover/commits/main) [![coverage report](https://gitlab.com/paulswartz/emqtt_failover/badges/main/coverage.svg)](https://gitlab.com/paulswartz/emqtt_failover/commits/main)\n\nWrapper around [emqtt][emqtt] which provides support for\nfailing over between brokers.","ref":"readme.html","title":"EmqttFailover","type":"extras"},{"doc":"To publish messages to a topic:\n\n``` elixir\niex> {:ok, pid} = EmqttFailover.Connection.start_link(\n...    configs: [\n...      \"mqtts://test.mosquitto.org:8886\", \n...      \"mqtt://test.mosquitto.org:1883\"])\niex> EmqttFailover.Connection.publish(pid, \n...    %EmqttFailover.Message{topic: \"topic\", payload: \"payload\", qos: 1})\n:ok\n```\n\nTo subscribe to topics and react to the messages, implement the `EmqttFailover.ConnectionHandler` behaviour:\n\n``` elixir\ndefmodule Handler do\n  @behaviour EmqttFailover.ConnectionHandler\n  \n  def init(_opts) do\n    {:ok, []}\n  end\n  \n  def handle_connected(state) do\n    {:ok, [\"topic/a\", \"topic/b\"], state}\n  end\n  \n  def handle_message(%EmqttFailover.Message{} = _message, state) do\n    # react to the message\n    {:ok, state}\n  end\nend\n\niex> {:ok, pid} = EmqttFailover.Connection.start_link(\n...    configs: [\"mqtts://test.mosquitto.org:8886\"],\n...    handler: Handler)\n```","ref":"readme.html#examples","title":"Examples - EmqttFailover","type":"extras"},{"doc":"The package can be installed by adding `emqtt_failover` to your list of dependencies in `mix.exs`:\n\n``` elixir\ndef deps do\n  [\n    {:emqtt_failover, \"~> 0.3\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - EmqttFailover","type":"extras"},{"doc":"View the full API documentation on [Hexdocs][hexdocs] or [GitLab Pages](glp).","ref":"readme.html#documentation","title":"Documentation - EmqttFailover","type":"extras"},{"doc":"```sh\n> docker compose start\n> mix test  # or mix coveralls.html\n> mix format\n> mix credo --strict\n> mix dialyzer --format dialyzer\n> mix docs\n```","ref":"readme.html#local-development","title":"Local development - EmqttFailover","type":"extras"},{"doc":"Code from [emqtt][emqtt] is (c) EMQ Technologies Co, Ltd. under the Apache License, Version 2.0.\n\nOther code is released under the [MIT license][LICENSE]. \n\n[emqtt]: https://github.com/emqx/emqtt\n[hexdocs]: https://hexdocs.pm/emqtt_failover\n[glp]: https://paulswartz.gitlab.io/emqtt_failover/readme.html\n[LICENSE]: ./LICENSE","ref":"readme.html#license","title":"License - EmqttFailover","type":"extras"},{"doc":"MIT License\n\nCopyright (c) 2023 Paul Swartz\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.\n\n\nParts of the `:emqtt` library are included, under the Apache License, Version\n2.0. See the license header in those files for the full license.","ref":"license.html","title":"LICENSE","type":"extras"}]}